//
//  servizioTemplate.h
//  ASD
//
//  Created by Paolo on 07/11/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#ifndef ASD_servizioTemplate_h
#define ASD_servizioTemplate_h
#include "lista.h"
#include "coda.h"

template <class T>
void Messaggio(Lista <T> l){
    string messaggio;
    messaggio = l.listaVuota()? "La lista è vuota":"La lista è piena";
    cout << endl << messaggio << endl;
};

//per poter creare la funzione di caricamento o stampa bisogna fare l'overloading della funzione per ogni tipo di dato gestito oppure creare funzione stampa() all'interno del tipo di dato.
void CaricaLista(Lista <Testo> &);
void CaricaLista(Lista <Persona> &);
void caricaCoda(Coda <Persona> &);

void stampaLista(Lista <Testo>);
void stampaLista(Lista <Persona>);
void stampaCoda(Coda <Persona>);


//Implementazioni dei metodi
void CaricaLista(Lista<Testo> & l){
    //acquisizione dati
    Testo t("Algoritmi e Strutture Dati", 1);
    Nodo<Testo>* p=l.primoLista();
    l.insLista(t,p);
    
    t.setTesto("Basi di dati", 2);
    p=l.primoLista();
    l.insLista(t,p);
    
    //p=l.succLista(p);
    t.setTesto("Architetture degli elaboratori",3);
    l.insLista(t, p);
};

void CaricaLista(Lista<Persona> & l){
    Persona persona;
    persona.setNome("Pippo");
    
    Nodo<Persona>* p=l.primoLista();
    l.insLista(persona,p);
    
    persona.setNome("Pluto");
    p=l.primoLista();
    l.insLista(persona,p);
    
    persona.setNome("Paperino");
    p=l.succLista(p);
    l.insLista(persona,p);
};

void caricaCoda(Coda<Persona> & c){
    Persona persona("Antonio");
    c.inCoda(persona);
    persona.setNome("Luciano");
    c.inCoda(persona);
    persona.setNome("Maria");
    c.inCoda(persona);
}

void stampaLista(Lista<Persona> l){
    Nodo<Persona>* p;
    Persona elemento;
    p=l.primoLista();
    if (p!=NULL) {
        cout << "elementi della lista: "<<endl;
    }
    while (!l.fineLista(p)){
        elemento=l.leggiLista(p);
        cout << elemento.getNome() << endl;
        p=l.succLista(p);
    }
    cout<<endl;
}
void stampaLista(Lista<Testo> l){
    Nodo<Testo>* p;
    Testo elemento;
    p=l.primoLista();
    if (p!=NULL) {
        cout << "Elementi della lista: "<<endl;
    }
    while (!l.fineLista(p)){
        elemento=l.leggiLista(p);
        cout << elemento.getCodice() << " " << elemento.getTitolo() << endl;
        p=l.succLista(p);
    }
    cout<<endl;

}

void stampaCoda(Coda<Persona> c){
    Persona elemento;
    while (!c.codaVuota()){
        elemento=c.leggiCoda();
        cout << elemento.getNome() << endl;
        c.fuoriCoda();
    }
    cout<<endl;

}

#endif
